<history>
  <h1>Recent changes</h1>
  <form onsubmit={ this.filter } class=row>
    <div>
      <label>Action</label>
      <select name=action onchange={ this.actionChanged }>
        <option value="">All</option>
        <option value=create>Created</option>
        <option value=update>Modified</option>
        <option value=delete>Deleted</option>
      </select>
    </div>

    <div if={ this.action == 'update' }>
      <label>Field concerned</label>
      <select name=field>
          <option value="">All</option>
          <option value="cell_phone">cell phone</option>
          <option value="comment">comment</option>
          <option value="country">country</option>
          <option value="diseases">diseases</option>
          <option value="email">email</option>
          <option value="groupings">groupings</option>
          <option value="events">events</option>
          <option value="first_name">first name</option>
          <option value="groups">groups</option>
          <option value="keywords">keywords</option>
          <option value="languages">languages</option>
          <option value="last_name">last name</option>
          <option value="phone">phone</option>
          <option value="roles">roles</option>
          <option value="title">title</option>
      </select>
    </div>

    <button><icon figure=filter></icon>Filter</button>
  </form>

  <div class=row>
    <button onclick={ this.toggleCollapse }>Collapse / Extend All</button>
    <button onclick={ this.download }>Download in JSON</button>
  </div>

  <hr>
  <diffs diffs={ this.opts.changes } withcontext={ true } collapse={ this.collapse } />

  <script>
    this.action = ''
    this.collapse = true

    this.filter = (event) => {
      event.preventDefault()
      page(replaceQueryParams(serializeForm(event.target), false))
    }

    this.actionChanged = (event) => {
      this.action = event.target.value
    }

    this.toggleCollapse = () => {
      this.collapse = !this.collapse
    }

    this.download = async () => {
      const response = apiResponse(await api(replaceQueryParams({ limit: 1000 }))) // use the current url as is.
      const filename = `log-of-logs.json`
      if (response.ok) download(filename, JSON.stringify(response.data), response.headers)
    }
  </script>

  <style>
    form.row {
      align-items: flex-end;
    }
  </style>
</history>
